// (c) 2010 11n.de, Michael Papesch
// For authentification of Serendipity 1.2.1 against phpbb3 encrypted passwords
// change the function serendipity_authenticate_author in the file 
// /serendipity/www/include/functions_config.inc.php
// to the following code
// Will work for later Versions, maybe;-)

// For manual adjustments in later versions i marked the 2 new code parts
//
// Watch for the 2 code blocks marked with ADDED, these are new

/**
 * Perform user authentication routine
 *
 * If a user is already authenticated via session data, this bypasses some routines.
 * After a user has ben authenticated, several SESSION variables ar set.
 * If the authentication fails, the session is destroyed.
 *
 * @access public
 * @param   string      The username to check
 * @param   string      The password to check (may contain plaintext or MD5 hash)
 * @param   boolean     Indicates whether the input password is already in MD5 format (TRUE) or not (FALSE).
 * @param   boolean     Indicates whether to query external plugins for authentication
 * @return  boolean     True on success, False on error
 */
function serendipity_authenticate_author($username = '', $password = '', $is_md5 = false, $use_external = true) {
    global $serendipity;


    if (isset($_SESSION['serendipityUser']) && isset($_SESSION['serendipityPassword']) && isset($_SESSION['serendipityAuthedUser']) && $_SESSION['serendipityAuthedUser'] == true) {
        $username = $_SESSION['serendipityUser'];
        $password = $_SESSION['serendipityPassword'];
        // For safety reasons when multiple blogs are installed on the same host, we need to check the current author each time to not let him log into a different blog with the same sessiondata
        $is_md5 = true;
    }

    $is_authenticated = false;
    serendipity_plugin_api::hook_event('backend_login', $is_authenticated, NULL);
    if ($is_authenticated) {
        return true;
    }

// ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1 ADDED 1
// from here

   $itoa64 = './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';


	if ($username != '') {
		if ($use_external) {
		serendipity_plugin_api::hook_event('backend_auth', $is_md5, array('username' => $username, 'password' => $password));
       	}
	$query = "SELECT password FROM {$serendipity['dbPrefix']}authors WHERE username = '".serendipity_db_escape_string($username)."'";
       	$row = serendipity_db_query($query, true, 'assoc');
		if (is_array($row)) {
		$tmphash = $row['password'];
		$hashpass = hash_it($password, $tmphash , $itoa64);
		$hashpass = substr($hashpass,0,-2);
	
			if ($hashpass == $tmphash) {
      			$query = "SELECT DISTINCT email, realname, authorid, userlevel, right_publish 
			FROM {$serendipity['dbPrefix']}authors 
			WHERE username = '".serendipity_db_escape_string($username)."' 
			AND password = '".serendipity_db_escape_string($hashpass)."'";
        		$row =& serendipity_db_query($query, true, 'assoc');
		 		if (is_array($row)) {
      		 		serendipity_setCookie('old_session', session_id(), false);
          		 		if (!$is_md5) {
            		    		serendipity_setAuthorToken();
           		 		}
           			$_SESSION['serendipityUser']        = $serendipity['serendipityUser']         = $username;
            			$_SESSION['serendipityRealname']    = $serendipity['serendipityRealname']     = $row['realname'];
           			$_SESSION['serendipityPassword']    = $serendipity['serendipityPassword']     = $hashpass;
           			$_SESSION['serendipityEmail']       = $serendipity['serendipityEmail']        = $row['email'];
           			$_SESSION['serendipityAuthorid']    = $serendipity['authorid']                = $row['authorid'];
           			$_SESSION['serendipityUserlevel']   = $serendipity['serendipityUserlevel']    = $row['userlevel'];
           			$_SESSION['serendipityAuthedUser']  = $serendipity['serendipityAuthedUser']   = true;
           			$_SESSION['serendipityRightPublish']= $serendipity['serendipityRightPublish'] = $row['right_publish'];
           			serendipity_load_configuration($serendipity['authorid']);
           	 		serendipity_setCookie('userDefLang', $serendipity['lang'], false);
            			return true;
        			}
 				else {
           			$_SESSION['serendipityAuthedUser'] = false;
				}
			}
		}
	}

// to here
// ADDED 1 END ADDED 1 END ADDED 1 END ADDED 1 END ADDED 1 END ADDED 1 END ADDED 1 END

    if ($username != '') {
        if ($use_external) {
            serendipity_plugin_api::hook_event('backend_auth', $is_md5, array('username' => $username, 'password' => $password));
        }


        if ($is_md5 === false && !empty($password)) {
            $password = md5($password);
        }


        $query = "SELECT DISTINCT
                    email, realname, authorid, userlevel, right_publish
                  FROM
                    {$serendipity['dbPrefix']}authors
                  WHERE
                    username   = '" . serendipity_db_escape_string($username) . "'
                  AND password = '" . serendipity_db_escape_string($password) . "'";
        $row =& serendipity_db_query($query, true, 'assoc');

        if (is_array($row)) {
            serendipity_setCookie('old_session', session_id(), false);
            if (!$is_md5) {
                serendipity_setAuthorToken();
            }
            $_SESSION['serendipityUser']        = $serendipity['serendipityUser']         = $username;
            $_SESSION['serendipityRealname']    = $serendipity['serendipityRealname']     = $row['realname'];
            $_SESSION['serendipityPassword']    = $serendipity['serendipityPassword']     = $password;
            $_SESSION['serendipityEmail']       = $serendipity['serendipityEmail']        = $row['email'];
            $_SESSION['serendipityAuthorid']    = $serendipity['authorid']                = $row['authorid'];
            $_SESSION['serendipityUserlevel']   = $serendipity['serendipityUserlevel']    = $row['userlevel'];
            $_SESSION['serendipityAuthedUser']  = $serendipity['serendipityAuthedUser']   = true;
            $_SESSION['serendipityRightPublish']= $serendipity['serendipityRightPublish'] = $row['right_publish'];
            serendipity_load_configuration($serendipity['authorid']);
            serendipity_setCookie('userDefLang', $serendipity['lang'], false);
            return true;
        } else {
            $_SESSION['serendipityAuthedUser'] = false;
            serendipity_session_destroy();
        }
    }

    return false;
}

// ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2 ADDED 2
// and here

// This is copy/paste of phpBB's
// _hash_crypt_private function
function hash_it($password, $setting, &$itoa64)
{
   $output = '*';
   // Check for correct hash
   if (substr($setting, 0, 3) != '$H$')
   {
      return $output;
   }
   $count_log2 = strpos($itoa64, $setting[3]);
   if ($count_log2 < 7 || $count_log2 > 30)
   {
      return $output;
   }
   $count = 1 << $count_log2;
   $salt = substr($setting, 4, 8);
   if (strlen($salt) != 8)
   {
      return $output;
   }
   /**
   * We're kind of forced to use MD5 here since it's the only
   * cryptographic primitive available in all versions of PHP
   * currently in use.  To implement our own low-level crypto
   * in PHP would result in much worse performance and
   * consequently in lower iteration counts and hashes that are
   * quicker to crack (by non-PHP code).
   */
   if (PHP_VERSION >= 5)
   {
      $hash = md5($salt . $password, true);
      do
      {
         $hash = md5($hash . $password, true);
      }
      while (--$count);
   }
   else
   {
      $hash = pack('H*', md5($salt . $password));
      do
      {
         $hash = pack('H*', md5($hash . $password));
      }
      while (--$count);
   }

   $output = substr($setting, 0, 12);
   $output .= _hash_encode64($hash, 16, $itoa64);

   return $output;
}

// Copy/paste of phpBB's function
function _hash_encode64($input, $count, &$itoa64)
{
   $output = '';
   $i = 0;
   do
   {
      $value = ord($input[$i++]);
      $output .= $itoa64[$value & 0x3f];

      if ($i < $count)
      {
         $value |= ord($input[$i]) << 8;
      }
      $output .= $itoa64[($value >> 6) & 0x3f];
      if ($i++ >= $count)
      {
         break;
      }
      if ($i < $count)
      {
         $value |= ord($input[$i]) << 16;
      }
      $output .= $itoa64[($value >> 12) & 0x3f];
      if ($i++ >= $count)
      {
         break;
      }
      $output .= $itoa64[($value >> 18) & 0x3f];
   }
   while ($i < $count);
   return $output;
}

// to here
// ADDED 2 END ADDED 2 END ADDED 2 END ADDED 2 END ADDED 2 END ADDED 2 END ADDED 2 END